<?php
/**
 * @version		$Id: controller.php 189 2008-09-15 10:58:00 econtentsupport@gmail.com $
 * @package		Econtent
 * @subpackage		controller
 * @author 		E-Content 
 * @license		GNU/GPL, see http://www.fsf.org/licensing/licenses/gpl-howto.html
 */

/**
* @Copyright Copyright (C) 2010- econtent
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/

/**
 * @package		Econtent
 * @subpackage		controller
 */

jimport('joomla.application.component.controller');

/**
 * E-Content Component Controller
 *
 * @package		econtent_translator
 */
class EcontentController extends JController
{
	/**
	 * Method to display the view
	 *
	 * @access	public
	 */
	function display()
	{		
		$this->linkmanager();
	}
	
	function cpanel(){
		global $mainframe;
		$document 	= &JFactory::getDocument();
		$vType		= $document->getType();
		$vLayout 	= 'default';
		$mName		= 'cp_data';
		// Get/Create the view
		$view = &$this->getView( 'controlpanel', $vType);
		
		// Get/Create the model		
		if ($model = &$this->getModel($mName)) {
			// Push the model into the view (as default)
			$view->setModel($model, true);
		}
				
		// Set the layout
		$view->setLayout($vLayout);
		
		//display view
		$view->display();
	}
	
	function linkmanager(){
		global $mainframe;		
		
		$document 	= &JFactory::getDocument();
		$vType		= $document->getType();
		$vLayout 	= 'list';
		$mName		= 'linkmanager';
		// Get/Create the view
		$view = &$this->getView( 'linkmanager', $vType);
		// Get/Create the model
		
		if ($model = &$this->getModel($mName)) {
			// Push the model into the view (as default)
			$view->setModel($model, true);
		}
		
		// Set the layout
		$view->setLayout($vLayout);
		
		// Display the view		
		$view->display();
	}
	
	function linkcheck(){
		global $mainframe;		
		
		$document 	= &JFactory::getDocument();
		$vType		= $document->getType();
		$vLayout 	= 'list';
		$mName		= 'linkcheck';
		// Get/Create the view
		$view = &$this->getView( 'linkcheck', $vType);
		// Get/Create the model
		
		if ($model = &$this->getModel($mName)) {
			// Push the model into the view (as default)
			$view->setModel($model, true);
		}
		
		// Set the layout
		$view->setLayout($vLayout);
		
		// Display the view		
		$view->display();
	}
	
	function about(){
		global $mainframe;
		
		$document 	= &JFactory::getDocument();
		$vType		= $document->getType();
		$vLayout 	= 'about';
		$mName		= 'version';
		
		// Get/Create the view
		$view = &$this->getView( 'about', $vType);
		
		// Get/Create the model	
		$checkversion	=	&Econtent_utility::getVersion();
		$version	=	$checkversion['version'];
		$url		=	$checkversion['url'];
		$pc			=	$checkversion['productcode'];
		if ($model = &$this->getModel($mName,'', array('version'=> $version, 'url'=> $url , 'pc'=> $pc ))) {
			// Push the model into the view (as default)
			$view->setModel($model, true);
		}
				
		// Set the layout
		$view->setLayout($vLayout);
		
		//display view
		$view->display();
	}
	
	function restore(){
		if (JRequest::getCmd('task',null)=='doInstall'){
			JRequest::checkToken() or jexit( 'Invalid Token' );
		}
		$document 	= &JFactory::getDocument();
		$vType		= $document->getType();
		$vLayout 	= 'upload';
		$mName		= 'restore';
		// Get/Create the view
		$view = &$this->getView( 'restore', $vType);
		// Get/Create the model	
		
		$model = &$this->getModel($mName);
		if (JRequest::getCmd('task',null)=='doInstall'){
			if ($model->install()) {
				$cache = &JFactory::getCache('mod_menu');
				$cache->clean();
			}
		}
		$view->setModel($model, true);	
		// Set the layout
		$view->setLayout($vLayout);
		jimport('joomla.client.helper');
		$ftp =& JClientHelper::setCredentialsFromRequest('ftp');
		$view->assignRef('ftp', $ftp);
		// Display the view		
		$view->display();
	}
	
	function manualcron(){
		global $mainframe;		
		
		$document 	= &JFactory::getDocument();
		$vType		= $document->getType();
		$vLayout 	= 'list';
		$mName		= 'manualcron';
		// Get/Create the view
		$view = &$this->getView( 'manualcron', $vType);
		// Get/Create the model
		
		if ($model = &$this->getModel($mName)) {
			// Push the model into the view (as default)
			$view->setModel($model, true);
		}
		
		// Set the layout
		$view->setLayout($vLayout);
		
		// Display the view		
		$view->display();
	}

	function runcron() {
		global $mainframe;		
		
		$document 	= &JFactory::getDocument();
		$vType		= $document->getType();
		$vLayout 	= 'getlinks';
		$mName		= 'runcron';
		// Get/Create the view
		$view = &$this->getView( 'runcron', $vType);
		// Get/Create the model
		
		if ($model = &$this->getModel($mName)) {
			// Push the model into the view (as default)
			$view->setModel($model, true);
		}
		
		// Set the layout
		$view->setLayout($vLayout);
		
		// Display the view		
		$view->display();
	}
}
?>
