<?php
/**
 * @version		$Id: contentlink.php 189 2008-09-15 10:58:00 econtentsupport@gmail.com $
 * @package		Econtent
 * @subpackage		contentlink
 * @author 		E-Content 
 * @license		GNU/GPL, see http://www.fsf.org/licensing/licenses/gpl-howto.html
 */

/**
* @Copyright Copyright (C) 2010- econtent
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/

/**
 * @package		Econtent
 * @subpackage		contentlink
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport('joomla.application.component.model');

// Set the table directory
JTable::addIncludePath(JPATH_COMPONENT_ADMINISTRATOR.DS.'tables');

/**
 * Weblinks Component Weblink Model
 *
 * @package		Joomla
 * @subpackage	Content
 * @since 1.5
 */
class EcontentModelContentLink extends JModel
{	
	function getData(){		
		global $mainframe;
		// Initialize variables
		$doTask 	= JRequest::getCmd('task',null);
		
		$db			=& JFactory::getDBO();
		$user 		=& JFactory::getUser();
		$uid		= $user->get('id');
		$option		= JRequest::getCmd( 'option' );
		$cid		= JRequest::getVar( 'cid', array(0), '', 'array' );
	
		JArrayHelper::toInteger($cid, array(0));
		
		$edit		=	(strtolower($doTask) == 'news.edit') || ($cid[0]);
	
		$row =& JTable::getInstance('Econtent','Table');
		// load the row from the db table
		if ($edit)
			$row->load( $cid[0] );
			
		
	
//		 fail if checked out not by 'me'
		if ( JTable::isCheckedOut($user->get ('id'), $row->checked_out )) {
			$msg = JText::sprintf( 'DESCBEINGEDITTED', JText::_( 'The E-Content' ), $row->link );
			$mainframe->redirect( "index.php?option=$option&task=linkmanager", $msg );
		}
		
		if ( $edit ) {
			$row->checkout( $user->get('id'));			
			$row->ads			=	base64_decode($row->ads);
			$row->link			=	base64_decode($row->link);
			$row->getlink_reg	=	base64_decode($row->getlink_reg);
			$row->gettitle_reg	=	base64_decode($row->gettitle_reg);
			$row->getintro_reg	=	base64_decode($row->getintro_reg);
			$row->getfull_reg	=	base64_decode($row->getfull_reg);
			$row->find_replace_intro	=	base64_decode($row->find_replace_intro);
			$row->find_replace_intro_afterencode	=	base64_decode($row->find_replace_intro_afterencode);
			$row->find_replace_full	=	base64_decode($row->find_replace_full);
			$row->find_replace_full_afterencode	=	base64_decode($row->find_replace_full_afterencode);
			$row->find_replace_plugin	=	base64_decode($row->find_replace_plugin);
			$row->find_replace_plugin_afterencode	=	base64_decode($row->find_replace_plugin_afterencode);
			$row->nextpage_reg	=	base64_decode($row->nextpage_reg);
			$row->pagebreak_reg	=	base64_decode($row->pagebreak_reg);
			$row->find_replace_links	=	base64_decode($row->find_replace_links);
			$row->front_page_keyword	=	base64_decode($row->front_page_keyword);
		} else {
			$row->published 	= 1;
			$row->publish_time = 0;
			$row->publish_down = JText::_('Never');
			$row->time_update	=	60;	
			$row->numbercontent = 10;
			$row->get_img		=	1;
			$row->maxpixel		=	60;
		}	
		
		return $row;		
	}
	
	
	function getLists(){
		
		$db			=	&JFactory::getDBO();
		
		$cid		= JRequest::getVar( 'cid', array(0), '', 'array' );
	
		JArrayHelper::toInteger($cid, array(0));
		$doTask 	= JRequest::getCmd('task',null);
		$edit		=	strtolower($doTask) == 'news.edit';
		$sectionid	=	0;
	
		$row =& JTable::getInstance('Econtent','Table');
		// load the row from the db table
		if ($edit)
			$row->load( $cid[0] );
				
		$javascript = "onchange=\"changeDynaList( 'catid', sectioncategories, document.adminForm.sectionid.options[document.adminForm.sectionid.selectedIndex].value, 0, 0);\"";

		$query = 'SELECT s.id, s.title' .
				' FROM #__sections AS s' .
				' ORDER BY s.ordering';
		$db->setQuery($query);

		$sections[] = JHTML::_('select.option', '-1', '- '.JText::_('Select Section').' -', 'id', 'title');
		$sections[] = JHTML::_('select.option', '0', JText::_('Uncategorized'), 'id', 'title');
		$sections = array_merge($sections, $db->loadObjectList());
		$lists['sectionid'] = JHTML::_('select.genericlist',  $sections, 'sectionid', 'class="inputbox" size="1" '.$javascript, 'id', 'title', intval($row->sectionid));
		foreach ($sections as $section)
		{
			$section_list[] = (int) $section->id;
			// get the type name - which is a special category
			if ($row->sectionid) {
				if ($section->id == $row->sectionid) {
					$contentSection = $section->title;
				}
			} else {
				if ($section->id == $sectionid) {
					$contentSection = $section->title;
				}
			}
		}

		$sectioncategories = array ();
		$sectioncategories[-1] = array ();
		$sectioncategories[-1][] = JHTML::_('select.option', '-1', JText::_( 'Select Category' ), 'id', 'title');
		$section_list = implode('\', \'', $section_list);

		$query = 'SELECT id, title, section' .
				' FROM #__categories' .
				' WHERE section IN ( \''.$section_list.'\' )' .
				' ORDER BY ordering';
		$db->setQuery($query);
		$cat_list = $db->loadObjectList();

		// Uncategorized category mapped to uncategorized section
		$uncat = new stdClass();
		$uncat->id = 0;
		$uncat->title = JText::_('Uncategorized');
		$uncat->section = 0;
		$cat_list[] = $uncat;
		foreach ($sections as $section)
		{
			$sectioncategories[$section->id] = array ();
			$rows2 = array ();
			foreach ($cat_list as $cat)
			{
				if ($cat->section == $section->id) {
					$rows2[] = $cat;
				}
			}
			foreach ($rows2 as $row2) {
				$sectioncategories[$section->id][] = JHTML::_('select.option', $row2->id, $row2->title, 'id', 'title');
			}
		}
		$sectioncategories['-1'][] = JHTML::_('select.option', '-1', JText::_( 'Select Category' ), 'id', 'title');
		$categories = array();
		foreach ($cat_list as $cat) {
			if($cat->section == $row->sectionid)
				$categories[] = $cat;
		}

		$categories[] = JHTML::_('select.option', '-1', JText::_( 'Select Category' ), 'id', 'title');
		$lists['catid'] = JHTML::_('select.genericlist',  $categories, 'catid', 'class="inputbox" size="1"', 'id', 'title', intval($row->catid));		
		
		$category = ($row->id) ? $row->category : 1;
		$lists['category'] 		= JHTML::_('select.booleanlist',  'category', 'class="inputbox"', $category );	
		
		$get_img = ($row->id) ? $row->get_img : 0;
		$lists['get_img'] 		= JHTML::_('select.booleanlist',  'get_img', 'class="inputbox"', $get_img );
		
		$lists['sectioncategories']		=	$sectioncategories;
		
		// build the html radio buttons for published		
		$published = ($row->id) ? $row->published : 1;
		$lists['published'] 		= JHTML::_('select.booleanlist',  'published', 'class="inputbox"', $published );
		
		//created_by
		$lists['created_by']		=	JHTML::_('list.users', 'created_by', $row->created_by);
		
		// build the html radio buttons for category ads	
		$catads = ($row->id) ? $row->catads : 1;
		$lists['catads'] 		= JHTML::_('select.booleanlist',  'catads', 'class="inputbox"', $catads, 'Bottom of Intro', 'Top of Intro' );
		
		// build the html radio buttons for Extend Title Position	
		$title_ext_pos = ($row->id) ? $row->title_ext_pos : 1;
		$lists['title_ext_pos'] 		= JHTML::_('select.booleanlist',  'title_ext_pos', 'class="inputbox"', $title_ext_pos, 'Last of title', 'First of title' );
		
		// build the html radio buttons for option readmore	
		$readmore = ($row->id) ? $row->readmore : 0;
		$lists['readmore'] 		= JHTML::_('select.booleanlist',  'readmore', 'class="inputbox"', $readmore );
		
		//access
		$query	=	"SELECT * FROM #__groups";
		$db->setQuery($query);
		$group	=	$db->loadObjectList();
		
		$lists['access']			=	JHTML::_('select.genericlist', $group, 'access', 'class="inputbox" size="1"', 'id', 'name', $row->access);
		
		## Section & Category query
		$query = 'SELECT CONCAT_WS(",",s.id,c.id) AS `value`, CONCAT_WS(" / ", s.title, c.title) AS `text`' .
				' FROM #__sections AS s' .
				' INNER JOIN #__categories AS c ON c.section = s.id' .
				' WHERE s.scope = "content"' .
				' ORDER BY s.title, c.title';
		$db->setQuery($query);

		// Add a row for uncategorized content
		$uncat	= JHTML::_('select.option', '0,0', JText::_('UNCATEGORIZED'));
		$rows	= $db->loadObjectList();
		array_unshift($rows, $uncat);
		// build the html select list
		$lists['sectcat'] = JHTML::_('select.genericlist', $rows, 'sectcat', 'class="inputbox" size="10"', 'value', 'text', NULL);
		
		// build the html radio buttons for option readmore	
		$cut_content = ($row->id) ? $row->cut_content : 0;
		$lists['cut_content'] 		= JHTML::_('select.booleanlist',  'cut_content', 'class="inputbox"', $cut_content );
		
		// resize images
		$resizeimage = ($row->id) ? $row->resizeimage : 0;
		$lists['resizeimage']		= JHTML::_('select.booleanlist',  'resizeimage', 'class="inputbox"', $resizeimage );
		
		// Select plug-in for chart
		$query = "SELECT id, name FROM #__plugins WHERE folder = 'econtent_crawler' AND published = 1";
		$db->setQuery($query);		
		$plugin = $db->loadObjectList();
		$html	= '<select name="pid" id="pid">';
		$html	.='<option value="0">------------------</option>';
		$html	.= JHTML::_('select.options', $plugin, 'id', 'name', $row->pid );
		$html	.= '</select>';
		$lists['plugin_id']			= $html;
		
		// select dataway
		$dataway	=	($row->id) ? $row->dataway : 0;
		$obj		= 	new JObject();
		$obj->value	=	0;
		$obj->text	=	'MainIntro and Fulltext';
		$option[]	=	$obj;
		$obj		= 	new JObject();
		$obj->value	=	1;
		$obj->text	=	'Intro and Fulltext';
		$option[]	=	$obj;
		$obj		= 	new JObject();
		$obj->value	=	2;
		$obj->text	=	'Introtext and Cut text';
		$option[]	=	$obj;
		$obj		= 	new JObject();
		$obj->value	=	3;
		$obj->text	=	'MainIntro and Cut text';
		$option[]	=	$obj;
		$lists['dataway']		=	JHTML::_('select.genericlist', $option, 'dataway', 'class="inputbox" size="4"', 'value', 'text', $dataway);
		
		// pagebreak
		$lists['pagebreak']		=	JHTML::_('select.booleanlist',  'pagebreak', 'class="inputbox"', $row->pagebreak );
		
		// validate cookie
		$lists['cookie']		=	JHTML::_('select.booleanlist',  'validate_cookie', 'class="inputbox"', $row->validate_cookie );
		
		// rewrite code
		$lists['rewrite']		=	JHTML::_('select.booleanlist',  'rewrite', 'class="inputbox"', $row->rewrite );
		
		// front page
		$lists['front-page']	=	JHTML::_('select.booleanlist',  'front_page', 'class="inputbox"', $row->front_page );
		
		// returntask
		$lists['returntask']	=	JRequest::getCmd('returndotask');
		
		return $lists;
	}

	function getScript(){
		
		$script=
		"
			google.load(\"language\", \"1\");
			google.setOnLoadCallback(init);
			
			function init() 
			{				
				var t_from = document.getElementById('t_from');
				var t_to = document.getElementById('t_to');
				for (l in google.language.Languages) 
				{
					var lng = l.toLowerCase();
					lng 		= lng.substring(0,1).toUpperCase()+lng.substring(1,lng.length);
					var lngCode = google.language.Languages[l];
					if (google.language.isTranslatable(lngCode)) 
					{
						t_from.options.add(new Option(lng, lngCode));
						t_to.options.add(new Option(lng, lngCode));
					}
				}
			}";
		return $script;
	}
	
}
