<?php
/**
 * @version		$Id: linkmanager.php 189 2008-09-15 10:58:00 econtentsupport@gmail.com $
 * @package		Econtent
 * @subpackage		linkmanager
 * @author 		E-Content 
 * @license		GNU/GPL, see http://www.fsf.org/licensing/licenses/gpl-howto.html
 */

/**
* @Copyright Copyright (C) 2010- econtent
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/

/**
 * @package		Econtent
 * @subpackage		linkmanager
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport('joomla.application.component.model');

// Set the table directory
JTable::addIncludePath(JPATH_COMPONENT_ADMINISTRATOR.DS.'tables');

/**
 * Weblinks Component Weblink Model
 *
 * @package		Joomla
 * @subpackage	Content
 * @since 1.5
 */
class EcontentModelLinkManager extends JModel
{
	/**
	 * amMap data array
	 *
	 * @var array
	 */
	var $_data = null;	

	/**
	 * uri total
	 *
	 * @var integer
	 */
	var $_total = null;

	/**
	 * Pagination object
	 *
	 * @var object
	 */
	var $_pagination = null;

	/**
	 * Constructor
	 *
	 * @since 0.9
	 */
	function __construct()
	{
		parent::__construct();

		global $mainframe,$option;
		
		//$context			= 'com_content.viewcontent';
		$filter_order		= $mainframe->getUserStateFromRequest( $option.'.newscrawler.filter_order', 		'filter_order', 	'id',	'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'.newscrawler.filter_order_Dir',	'filter_order_Dir',	'',				'word' );
		$filter_state		= $mainframe->getUserStateFromRequest( $option.'.newscrawler.filter_state',		'filter_state',		'',	'word' );
		$catid				= $mainframe->getUserStateFromRequest( $option.'.newscrawler.catid',			'catid',			0,	'int' );
		$filter_sectionid	= $mainframe->getUserStateFromRequest( $option.'.newscrawler.filter_sectionid',	'filter_sectionid',	-1,	'int' );
		$search 			= $mainframe->getUserStateFromRequest( $option.'.newscrawler.search', 			'search', 			'',				'string' );
		$search 			= JString::strtolower( $search );
	
		$limit				= $mainframe->getUserStateFromRequest($option.'.newscrawler.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart			= $mainframe->getUserStateFromRequest($option.'.newscrawler.limitstart', 'limitstart', 0, 'int');
		
		$this->setState('limit', $limit);
		$this->setState('limitstart', $limitstart);
		$this->setState('catid', $catid);
		$this->setState('filter_sectionid', $filter_sectionid);
		$this->setState('search', $search);
		$this->setState('filter_state', $filter_state);

		// Get the filter request variables
		$this->setState('filter_order', $filter_order);
		$this->setState('filter_order_dir', $filter_order_Dir);
	}
	
	function getTotal()
	{
		// Lets load the total nr if it doesn't already exist
		if (empty($this->_total))
		{
			$query = $this->_buildQuery();
			$this->_total = $this->_getListCount($query);
		}

		return $this->_total;
	}
	
	function getPagination()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_pagination))
		{
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination( $this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
		}

		return $this->_pagination;
	}
	
	
	function getData(){
		$pop	= JRequest::getBool('pop');
		// Lets load the content if it doesn't already exist
		if (empty($this->_data))
		{
			$query = $this->_buildQuery();

			if ($pop) {
				$this->_data = $this->_getList( $query );
			} else {
				$this->_data = $this->_getList( $query, $this->getState('limitstart'), $this->getState('limit') );
			}
		}

		return $this->_data;
	}
	
	function _buildQuery(){
		// Get the WHERE and ORDER BY clauses for the query
		$where		= $this->_buildWhere();
		$orderby	= $this->_buildOrderBy();

		//Get Events from Database
		$query = ' SELECT ync . * , c.id AS catid, c.title AS catname, s.id AS secid, s.title AS secname
					FROM jos_econtent AS ync
					LEFT JOIN jos_categories AS c ON ync.catid = c.id
					LEFT JOIN jos_sections AS s ON ync.sectionid = s.id '
				. $where
				. $orderby
				;
		return $query;		
	}
	
	function _buildWhere( )
	{		
		
		$db						=		& JFactory::getDBO();
		$filter_state			=		$this->getState('filter_state');
		$search					=		$this->getState('search');
		$filter_sectionid		=		$this->getState('filter_sectionid');
		$catid					=		$this->getState('catid');
		$where = array();
		
		if ( $search ) {
			$where[] = 'ync.title LIKE '.$db->Quote( '%'.$db->getEscaped( $search, true ).'%', false );
		}
		
		// Section filter
		if ($filter_sectionid >= 0) {
			$where[] = 'ync.sectionid = ' . (int) $filter_sectionid;
		}
		// Category filter
		if ($catid > 0) {
			$where[] = 'ync.catid = ' . (int) $catid;
		}
		
		if ( $filter_state ) {
			if ( $filter_state == 'P' ) {
				$where[] = 'ync.published = 1';
			} else if ($filter_state == 'U' ) {
				$where[] = 'ync.published = 0';
			}
		}		
		$where 		= ( count( $where ) ? ' WHERE ' . implode( ' AND ', $where ) : '' );
					
		return $where;
	}
	
	function _buildOrderBy()
	{
		$filter_order		=	$this->getState('filter_order');
		$filter_order_Dir	=	$this->getState('filter_order_dir');
		
		if ($filter_order == 'id'){
			$orderby 	= ' ORDER BY id';
		} else {
			$orderby 	= ' ORDER BY '. $filter_order .' '. $filter_order_Dir .', id';
		}
		
		return $orderby;
	}
	
	function getLists(){
		
		$filter_sectionid		=		$this->getState('filter_sectionid');
		$catid					=		$this->getState('catid');
		
		if ($filter_sectionid >= 0) {
			$filter = ' WHERE cc.section = '. (int) $filter_sectionid;
		}
		
		// get list of categories for dropdown filter
		$query = 'SELECT cc.id AS value, cc.title AS text, section' .
				' FROM #__categories AS cc' .
				' INNER JOIN #__sections AS s ON s.id = cc.section ' .
				$filter .
				' ORDER BY s.ordering, cc.ordering';
		$lists['catid'] = $this->filterCategory($query, $catid);

		// get list of sections for dropdown filter
		$javascript = 'onchange="document.adminForm.submit();"';
		$lists['sectionid'] = JHTML::_('list.section', 'filter_sectionid', $filter_sectionid, $javascript);
		
		// state filter
		$lists['state'] = JHTML::_('grid.state', $this->getState('filter_state'), 'Published', 'Unpublished');
		
		// table ordering
		$lists['order_Dir']	= $this->getState('filter_order_dir');
		$lists['order']		= $this->getState('filter_order');
		
		// search filter
		$lists['search']= $this->getState('search');
		
		return $lists;
	}
	
	function filterCategory($query, $active = NULL)
	{
		// Initialize variables
		$db	= & JFactory::getDBO();

		$categories[] = JHTML::_('select.option', '0', '- '.JText::_('Select Category').' -');
		$db->setQuery($query);
		$categories = array_merge($categories, $db->loadObjectList());

		$category = JHTML::_('select.genericlist',  $categories, 'catid', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', $active);

		return $category;
	}
}
