<?php
/**
 * @version		$Id: contentlink.php 189 2008-09-15 10:58:00 econtentsupport@gmail.com $
 * @package		Econtent
 * @subpackage		contentlink
 * @author 		E-Content 
 * @license		GNU/GPL, see http://www.fsf.org/licensing/licenses/gpl-howto.html
 */

/**
* @Copyright Copyright (C) 2010- econtent
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/

/**
 * @package		Econtent
 * @subpackage		contentlink
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport( 'joomla.application.component.view');

// Set the table directory
JTable::addIncludePath(JPATH_COMPONENT_ADMINISTRATOR.DS.'tables');

/**
 * HTML View class for the E-Content views
 *
 * @static
 * @package		Econtent
 * @subpackage	Econtent_Crawler
 * @since 1.0
 */
class EcontentViewContentLink extends JView
{
	function display(){
		global $mainframe;
		JHTML::stylesheet( 'econtent.css', 'administrator/components/com_econtent/assets/' );	
		$doTask 	= JRequest::getCmd('task',null);
		$edit		=	strtolower($doTask) == 'news.edit';
		JHTML::_('behavior.mootools');
		$document =& JFactory::getDocument();
		$document->addScript('components/com_econtent/assets/base64.js');
		$document->addScript('components/com_econtent/assets/step.js');
		$document->addScript('http://www.google.com/jsapi');
//		$document->addScript('components/com_econtent/assets/tds.js');
//		$document->addScriptDeclaration("
//			
//			var Site = {
//
//	                start: function(){
//	                        new TextDropShadow($('textpanel'), {color:'#777'});
//	                }
//	
//	        };
//	
//	        window.addEvent('load', Site.start);
//		");
		
		$document->addScriptDeclaration($this->get('Script'));
		$row	=	$this->get('Data');
		$lists	=	$this->get('Lists');
		$this->_setToolBarEdit($edit);		
		
		$this->assignRef('row',$row);
		$this->assignRef('lists', $lists);
		parent::display();
	}
	
	function _setToolBarEdit($edit){
		$cid = JRequest::getVar( 'cid', array(0), '', 'array' );
		$cid = intval($cid[0]);

		$text = ( $edit ? JText::_( 'Edit' ) : JText::_( 'New' ) );
		$bar =& JToolBar::getInstance('toolbar');
		JToolBarHelper::title( JText::_( 'Content News' ).': <small><small>[ '. $text.' ]</small></small>', 'addedit.png' );
		// Add a next button
		$dhtml = "<a id=\"toolbar-preview\" href=\"#\">
							<span title=\"Next\" class=\"icon-32-preview\"><!--span--></span>
							Preview
						</a>";
		$bar->appendButton( 'Custom', $dhtml, 'Preview' );
		
		JToolBarHelper::save('news.save');
		JToolBarHelper::apply('news.apply');
				
		// Add a back button
		$dhtml = "<a class=\"toolbar\" onclick=\"javascript:hideMainMenu(); submitbutton('news.back')\" href=\"#\">
							<span title=\"Next\" class=\"icon-32-back\"><!--span--></span>
							Back
						</a>";
		$bar->appendButton( 'Custom', $dhtml, 'back' );
		
		// Add a next button
		$dhtml = "<a class=\"toolbar\" onclick=\"javascript:hideMainMenu(); submitbutton('news.next')\" href=\"#\">
							<span title=\"Next\" class=\"icon-32-next\"><!--span--></span>
							Next
						</a>";
		$bar->appendButton( 'Custom', $dhtml, 'next' );
		
		
		
		if ( $edit ) {
			// for existing articles the button is renamed `close`
			JToolBarHelper::cancel( 'news.cancel', 'Close' );
		} else {
			JToolBarHelper::cancel('news.cancel');
		}
	}
}
