<?php
/**
 * @version		$Id: runcron.php 189 2008-09-15 10:58:00 econtentsupport@gmail.com $
 * @package		Econtent
 * @subpackage		View Control Panel
 * @author 		E-Content 
 * @copyright	Copyright (C) 2005 - 2008 E-Content. All rights reserved.
 * @license		GNU/GPL, see http://www.fsf.org/licensing/licenses/gpl-howto.html
 */

/**
 * @package		Econtent
 * @subpackage		View Control Panel
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport( 'joomla.application.component.view');

// Set the table directory
JTable::addIncludePath(JPATH_COMPONENT_ADMINISTRATOR.DS.'tables');

/**
 * @version		$Id: runcron.php 189 2008-09-15 10:58:00 econtentsupport@gmail.com $
 * @package		Econtent
 * @subpackage		Viewcontrolpanel
 * @author 		E-Content 
 * @license		GNU/GPL, see http://www.fsf.org/licensing/licenses/gpl-howto.html
 */

/**
* @Copyright Copyright (C) 2010- econtent
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/

/**
 * @package		Econtent
 * @subpackage		Viewcontrolpanel
 */

class EcontentViewControlPanel extends JView
{
	function display($tpl = null){
		JHTML::stylesheet( 'econtent.css', 'administrator/components/com_econtent/assets/' );
		
		global $mainframe;			

		JToolBarHelper::title(JText::_( 'Control Panel' ), 'logo');
		
		JToolBarHelper::preferences('com_econtent', '460');
		JSubMenuHelper::addEntry('Control Panel', 'index.php?option=com_econtent&task=cpanel', true);
		JSubMenuHelper::addEntry('Links Manager', 'index.php?option=com_econtent&task=linkmanager', false);
		JSubMenuHelper::addEntry('Manual Cron Job', 'index.php?option=com_econtent&task=manualcron', false);
		JSubMenuHelper::addEntry('Links Received', 'index.php?option=com_econtent&task=linkcheck', false);
		JSubMenuHelper::addEntry('Restore', 'index.php?option=com_econtent&task=restore', false);
		$xml = & JFactory::getXMLParser('Simple');
		$config =& JComponentHelper::getParams('com_econtent');

		if ($xml->loadFile(JPATH_COMPONENT_ADMINISTRATOR.DS.'helpers'.DS.'version.xml'))
		{
			if (!$version = & $xml->document->version) {
				return false;
			}
		} else {
			return false;
		}
		
		$updatecode	=	$config->get('code_update');
		
		JHTML::_('behavior.tooltip');
		$this->assignRef('version',	$version[0]->data());
		$this->assignRef('totallink', $this->get('TotalLink'));
		$this->assignRef('totalerror', $this->get('TotalError'));
		$this->assignRef('totalfeed', $this->get('TotalFeed'));
		$this->assignRef('totalreceived', $this->get('TotalReceived'));
		$this->assign('updatecode', $updatecode);
		parent::display($tpl);
	}
	
	function quickIconButton( $link, $image, $text ) {
		
		$lang	= &JFactory::getLanguage();
		$button = '';
		if ($lang->isRTL()) {
			$button .= '<div style="float:right;">';
		} else {
			$button .= '<div style="float:left;">';
		}
		$button .=	'<div class="icon">'
				   .'<a href="'.$link.'">'
				   .JHTML::_('image.site',  $image, '/components/com_econtent/assets/images/', NULL, NULL, $text )
				   .'<span>'.$text.'</span></a>'
				   .'</div>';
		$button .= '</div>';

		return $button;
	}
	
}
