<?php
/**
 * @version		$Id: viewlinkmanager.php 189 2008-09-15 10:58:00 econtentsupport@gmail.com $
 * @package		Econtent
 * @subpackage		viewlinkmanager
 * @author 		E-Content 
 * @license		GNU/GPL, see http://www.fsf.org/licensing/licenses/gpl-howto.html
 */

/**
* @Copyright Copyright (C) 2010- econtent
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/

/**
 * @package		Econtent
 * @subpackage		viewlinkmanager
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport( 'joomla.application.component.view');

// Set the table directory
JTable::addIncludePath(JPATH_COMPONENT_ADMINISTRATOR.DS.'tables');

/**
 * HTML View class for the E-Content views
 *
 * @static
 * @package		Econtent
 * @subpackage	Econtent_Crawler
 * @since 1.0
 */
class EcontentViewLinkManager extends JView
{
	function display($tpl = null)
	{
		global $mainframe,$option;
		
		// Set the toolbar
		$this->_setToolBar();
		
		$option				= JRequest::getCmd( 'option' );
		
		$rows	=	$this->get('Data');
		$pageNav=	$this->get('Pagination');
		$lists	=	$this->get('Lists');		
		$this->assignRef('lists',$lists);
		$this->assignRef('rows',$rows);
		$this->assignRef('pageNav',$pageNav);
		$this->assign('option',$option);
		parent::display($tpl);
		
	}	

	function _setToolBar()
	{
		JHTML::stylesheet( 'econtent.css', 'administrator/components/com_econtent/assets/' );		
		JToolBarHelper::title( JText::_( 'E-Content Manager' ), 'news' );
		JToolBarHelper::publishList('news.publish');
		JToolBarHelper::unpublishList('news.unpublish');		
		JToolBarHelper::deleteList('Are you sure?','news.remove');
		JToolBarHelper::editListX('news.edit');
		JToolBarHelper::addNewX('news.new');
		JToolBarHelper::archiveList('news.archive', 'Backup');
		JToolBarHelper::preferences('com_econtent', '300');
		JSubMenuHelper::addEntry('Control Panel', 'index.php?option=com_econtent&task=cpanel', false);
		JSubMenuHelper::addEntry('Links Manager', 'index.php?option=com_econtent&task=linkmanager', true);
		JSubMenuHelper::addEntry('Manual Cron Job', 'index.php?option=com_econtent&task=manualcron', false);
		JSubMenuHelper::addEntry('Links Received', 'index.php?option=com_econtent&task=linkcheck', false);
		JSubMenuHelper::addEntry('Restore', 'index.php?option=com_econtent&task=restore', false);
	}
	
	
}
