<?php
/**
 * @version		$Id: viewmanualcron.php 189 2008-09-15 10:58:00 econtentsupport@gmail.com $
 * @package		Econtent
 * @subpackage		viewmanualcron
 * @author 		E-Content 
 * @license		GNU/GPL, see http://www.fsf.org/licensing/licenses/gpl-howto.html
 */

/**
* @Copyright Copyright (C) 2010- econtent
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/

/**
 * @package		Econtent
 * @subpackage		viewmanualcron
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport( 'joomla.application.component.view');

// Set the table directory
JTable::addIncludePath(JPATH_COMPONENT_ADMINISTRATOR.DS.'tables');

/**
 * HTML View class for the E-Content views
 *
 * @static
 * @package		Econtent
 * @subpackage	Econtent_Crawler
 * @since 1.0
 */
class EcontentViewManualCron extends JView
{
	function display($tpl = null)
	{
		global $mainframe,$option;
		
		// Set the toolbar
		$this->_setToolBar();
		
		$option				= JRequest::getCmd( 'option' );
		
		$rows	=	$this->get('Data');
		$pageNav=	$this->get('Pagination');
		$lists	=	$this->get('Lists');
		
		JHTML::_('behavior.tooltip');
		$document =& JFactory::getDocument();
		
		$document->addScript('components/com_econtent/assets/ext-base.js');
		$document->addScript('components/com_econtent/assets/ext-all.js');
		$document->addScript('components/com_econtent/assets/base64.js');
		$document->addScript('components/com_econtent/assets/progress-bar.js');		
		$document->addStyleSheet('components/com_econtent/assets/progress-bar.css');		
		$document->addStyleSheet('components/com_econtent/assets/ext-all.css');
		
		$initprogress	=	'';
		for ($i=0; $i<count($rows); $i++) {
			$initprogress	.=	"var pgbar$i = new Ext.ProgressBar({
							        text:'Ready',
							        id:'pgbar$i',
							        cls:'left-align',
							        renderTo:'progress-$i'
							    });";			
		}
		
		$initevent		=	'';
		for ($i=0; $i<count($rows); $i++){
			$initevent		.=	"
								if ($('cb$i').checked) {
									var myPage$i = new Element('div', {
										'id': 'matchpage$i'
									});									
									myPage$i.inject($('result'));
									var myCheck$i = new Element('div', {
										'id': 'checkpage$i'
									});
									myCheck$i.inject($('checkresult'));
									pgbar$i.reset();
									pgbar$i.updateText('Initialization...');
									new Ajax('index.php?option=com_econtent&task=news.getcount&index=$i&id='+$('cb$i').getProperty('value'), {
										method: 'get',
										update: myPage$i,
										onComplete: function() {	
											if (document.adminForm.count".$rows[$i]->id.".value == 0) {
												pgbar$i.updateText('Error!');
											} else {
												Runner.run(pgbar$i, document.adminForm.count".$rows[$i]->id.".value, function(){
									           		pgbar$i.updateText('Done.');
										        }, 0, ".$rows[$i]->id.", ".$rows[$i]->category.", 0, $i);
											}
									        
										}
										
									}).request();   			
					    		}
								";
		}
		
		$document->addScriptDeclaration("
			
			Ext.onReady(function(){
				
				$initprogress
				
		       	var btn = Ext.get('toolbar-capture');
			    btn.on('click', function(){
			    	$('result').empty();
			    	$('checkresult').empty();
			    	$initevent
			    });
			});
		");
		
		$this->assignRef('lists',$lists);
		$this->assignRef('rows',$rows);
		$this->assignRef('pageNav',$pageNav);
		$this->assign('option',$option);
		parent::display($tpl);		
	}	

	function _setToolBar()
	{
		JHTML::stylesheet( 'econtent.css', 'administrator/components/com_econtent/assets/' );
		JToolBarHelper::title( JText::_( 'Manual Cron Job' ), 'cron' );
		$bar =& JToolBar::getInstance('toolbar');
		// Add a back button
		$dhtml = "<a class=\"toolbar\" onclick=\"javascript:hideMainMenu(); \" href=\"#\">
							<span title=\"Capture\" class=\"icon-32-capture\"><!--span--></span>
							Capture
						</a>";
		$bar->appendButton( 'Custom', $dhtml, 'capture' );
		JToolBarHelper::preferences('com_econtent', '300');
		JSubMenuHelper::addEntry('Control Panel', 'index.php?option=com_econtent&task=cpanel', false);
		JSubMenuHelper::addEntry('Links Manager', 'index.php?option=com_econtent&task=linkmanager', false);
		JSubMenuHelper::addEntry('Manual Cron Job', 'index.php?option=com_econtent&task=manualcron', true);
		JSubMenuHelper::addEntry('Links Received', 'index.php?option=com_econtent&task=linkcheck', false);
		JSubMenuHelper::addEntry('Restore', 'index.php?option=com_econtent&task=restore', false);
	}
	
	
}
