<?php
/**
 * @version		$Id: imageresizefactory.php 189 2008-09-15 10:58:00 econtentsupport@gmail.com $
 * @package		Econtent
 * @subpackage		imageresizefactory
 * @author 		E-Content 
 * @license		GNU/GPL, see http://www.fsf.org/licensing/licenses/gpl-howto.html
 */

/**
* @Copyright Copyright (C) 2010- econtent
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/

/**
 * @package		Econtent
 * @subpackage		imageresizefactory
 */
defined('_JEXEC') or die( 'Restricted access' );
require_once(JPATH_SITE.DS.'components'.DS.'com_econtent'.DS.'helpers'.DS.'cls_iresizer.php');
jimport('joomla.filesystem.file');

/**
* class ImageResizeFactory
*
* { Description :- 
*	This Class is a factory method class which returns the appropriate object of ImageResizeClass depending on the type of Image 
*	i.e jpg or Png.
* }
*/

class ImageResizeFactory
{
	/**
	* Method ImageResizeFactory::getInstanceOf()
	*
	* { Description :- 
	*	This method resizes the image.
	* }
	*/
	
	function getInstanceOf($imageName, $resizedImageName, $newWidth, $newHeight)
	{
		$info 		= @getimagesize($imageName);		

		if (($info[0] > $newWidth) || ($info[1] > $newHeight)) {
			
			$extension = JFile::getExt($imageName); 
			if(preg_match("/jpg|JPG|jpeg|JPEG/", $extension))
			{
				// Instantiate the correct object depending on type of image i.e jpg or png
				$dimg = new ImageResizer();
				// -- original image: load from file
				$dimg->loadImage($imageName);			
				$dimg->resize($newWidth,$newHeight);
				$r_img = $dimg->getResult();				
				imagejpeg($r_img, $resizedImageName);
				return true;
			}
			elseif(preg_match("/png|PNG/", $extension))
			{
				// Instantiate the correct object depending on type of image i.e jpg or png
				$dimg = new ImageResizer();
	
				// -- original image: load from file
				$dimg->loadImage($imageName);			
				$dimg->resize($newWidth,$newHeight);
				$r_img = $dimg->getResult();				
				imagepng($r_img, $resizedImageName);
				return true;
			}elseif (preg_match("/gif/i", $extension)) {
				// Instantiate the correct object depending on type of image i.e gif
				$dimg = new ImageResizer();
	
				// -- original image: load from file
				$dimg->loadImage($imageName);			
				$dimg->resize($newWidth,$newHeight);
				$r_img = $dimg->getResult();				
				imagegif($r_img, $resizedImageName);
				
				return true;
			}elseif (preg_match("/bmp/i", $extension)) {
				// Instantiate the correct object depending on type of image i.e gif
				$dimg = new ImageResizer();
	
				// -- original image: load from file
				$dimg->loadImage($imageName);			
				$dimg->resize($newWidth,$newHeight);
				$r_img = $dimg->getResult();				
				imagewbmp($r_img, $resizedImageName);
				
				return true;
			} else {
				return false;
			}
		} else {
			return false;
		}
	}
}
?>
