<?php
/**
 * @version		$Id: updatedata.php 189 2008-09-15 10:58:00 econtentsupport@gmail.com $
 * @package		Econtent
 * @subpackage		updatedata
 * @author 		E-Content 
 * @license		GNU/GPL, see http://www.fsf.org/licensing/licenses/gpl-howto.html
 */

/**
* @Copyright Copyright (C) 2010- econtent
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/

/**
 * @package		Econtent
 * @subpackage		updatedata
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport('joomla.application.component.model');

require_once(JPATH_COMPONENT.DS.'helpers'.DS.'getimg.php');
require_once(JPATH_COMPONENT.DS.'helpers'.DS.'autocuttext.php');
require_once(JPATH_COMPONENT.DS.'helpers'.DS.'HTTPFetcher.php');
require_once(JPATH_COMPONENT.DS.'helpers'.DS.'readfile.php');


// Set the table directory
JTable::addIncludePath(JPATH_COMPONENT.DS.'tables');

/**
 * Weblinks Component Weblink Model
 *
 * @package		Econtent
 * @subpackage	Update
 * @since 1.5
 */
class EcontentModelUpdatedata extends JModel
{
	function __construct(){
		parent::__construct();
		$code_update		=		JRequest::getString('code');
		$this->setState('code_update', $code_update);
	}
	function doGetNews(){
		global $mainframe;
		
		$config 		=& JComponentHelper::getParams('com_econtent');
		$config_code	= $config->get('code_update');
		$config_error	=$config->get('max_error',10);
		$config_percent	=$config->get('percentage',80);
		
		$MailFrom	= $mainframe->getCfg('mailfrom');
		$FromName	= $mainframe->getCfg('fromname');
		$SiteName	= $mainframe->getCfg('sitename');

		if (trim($config_code) != $this->getState('code_update')) {
			return false;
		}

		$update_lists	=	$this->getUpdateLists();

		for ($i =0; $i<count($update_lists); $i++) {
			$row =& JTable::getInstance('Econtent','Table');
			$row->load(intval($update_lists[$i]->id));
			if ($row->category == 1) {
				if (!$this->storeFeedDatas($row, $config_percent)) {					
					$row->error_counter	=	intval($row->error_counter) +1;
					if (intval($row->error_counter)>=intval($config_error)) {
						$subject = JText::_('ERROR NEWS CRAWLER');
						$message = $this->getMessage($row);
						if (!JUtility::sendMail( $MailFrom, $FromName, $MailFrom, $subject, $message, 1 )) {
							JError::raiseWarning(400,'Error: Email');						
						}
						$row->published	=	0;					
					}
					$row->store();
					echo $row->error_msg;
				} else {
					$row->error_counter	=	0;
					$row->error_msg		=	'';
					$row->last_update	=	date('Y-m-d H:i:s');
					$row->store();
				}
			} else {
				if (!$this->storeHTMLDatas($row, $config_percent)) {
					$row->error_counter	=	intval($row->error_counter) +1;	
					if (intval($row->error_counter)>=intval($config_error)) {
						$subject = JText::_('ERROR NEWS CRAWLER');
						$message = $this->getMessage($row);
						if (!JUtility::sendMail( $MailFrom, $FromName, $MailFrom, $subject, $message, 1 )) {
							JError::raiseWarning(400,'Error: Email');						
						}
						$row->published	=	0;					
					}
					$row->store();
					echo $row->error_msg;
				} else {
					$row->error_counter	=	0;
					$row->error_msg		=	'';
					$row->last_update	=	date('Y-m-d H:i:s');
					$row->store();
				}
			}
		}
		
		

	}
	
	/**
	 * Store Feed Rss data
	 *
	 * @param obj $update
	 * @return bool
	 */
	function storeFeedDatas(&$update, $config_percent){
		$dispatcher	=& JDispatcher::getInstance();
		if ($update->pid!=0) {			
			JPluginHelper::importPlugin('econtent_crawler');
			$rows  = null;
			$result = $dispatcher->trigger('onGetDataCrawler', array (&$update, &$rows,  true ));
			
			if (!$result) {
			    $update->error_msg .= '<strong>'.date('Y-m-d H:i:s').'</strong><font color="red"><strong>'.JText::_('NOTGETPLUGIN').':</strong></font> '.base64_decode($update->link)."<br />\n";
			    return false;
			}
			if (!$rows) {    
			    return false;
			}
			for ($i=0; $i<count($rows); $i++){
				$row	=	&JTable::getInstance('content');
				$link	=	&JTable::getInstance('Econtent_Content_Link','Table');
				$row->bind($rows[$i]);
				$link->link		=	$rows[$i]->link;
				$link->title	=	$rows[$i]->title;
				$link->sectionid=	$rows[$i]->sectionid;
				$link->catid	=	$rows[$i]->catid;
				$charset		=	$rows[$i]->charset;
			
				if ($charset!='auto') {
					$this->convert_utf_8($row, $charset, 0);
				}
				
				if ((trim($update->t_from)!='') && (trim($update->t_to)!='')) {
					$this->translate($row, $update->t_from, $update->t_to);
				}
				
				if ($update->rewrite) {
					$this->rewrite_data($row, $update);
				}
				
				if ($row->check() && $link->check()) {
					$result	=	$dispatcher->trigger('onBeforeContentSave', array (&$row, true ));
					$row->store();
					if ($row->id){
						if ($update->front_page) {
							// check to set front-page
							$front_page_keyword		=	base64_decode($update->front_page_keyword);
							if ($front_page_keyword) {
								if ($this->checkfrontpage_keyword($front_page_keyword, $row->title.' '.$row->introtext.' '.$row->fulltext)){
									$res = $this->setfrontpage($row->id);
								}
							} else {
								$res	=	$this->setfrontpage($row->id);
							}
						}
						
						$link->articleid	= $row->id;
					}
					$link->store();
					$result	=	$dispatcher->trigger('onAfterContentSave', array (& $row, true ));
				}
			}
			return true;
		}		
		
		$now	=	&JFactory::getDate();
		$now	=	$now->toMySQL();
		
		
		JPluginHelper::importPlugin('content');		
		$updatelink		=	base64_decode($update->link);
		$options['rssUrl']= $updatelink;
		$options['cache_time']=3600;
		$rssDoc =& JFactory::getXMLparser('RSS', $options);
		
		if (!$rssDoc) {
			$update->error_msg	.=	'<strong>'.date('Y-m-d H:i:s').'</strong><font color="red"><strong>'.JText::_('NOTGETLOCATION').':</strong></font> '.$updatelink."<br />\n";
			return false;
		}
		
		$econtent_utility	=	new Econtent_utility();
		
		$items	=	$rssDoc->get_items();
		$items	=	array_slice($items , 0, $update->numbercontent );
		
		$ok		=	0;
		foreach ($items as $item) {
			if (!$this->checkstore($item->get_link())) {
				continue;
			}
			$row	=	&JTable::getInstance('content');
			$link	=	&JTable::getInstance('Econtent_Content_Link','Table');
			if (!$this->checkkeyword($item->get_title(), $update) && !$this->checkkeyword($item->get_description(),$update)) {
				continue;
			}
			
			$row->title	=	$item->get_title();
			$desc			=	$this->filterdata($item->get_description(), base64_decode($update->find_replace_intro), base64_decode($update->find_replace_intro_afterencode), $update);			
			
			$ads			=	'<div class="ads_news">'.base64_decode($update->ads).'</div>';
			$readmore		=	(intval($update->readmore)) ? '<p class="readmore_news"><a href="'.$item->get_link().'">'.JText::_('VIEWDETAIL').'</a></p>' : '';
			
			$check			=	true;
			switch (intval($update->dataway)) {
				case 0:
					$introtext	=	$desc;
					$introtext	=	(intval($update->catads)) ? $introtext : $ads.$introtext;
					$fulltext	=	$this->getregtext($item->get_link(), base64_decode($update->getfull_reg), $update->getfull_sub, base64_decode($update->find_replace_full), base64_decode($update->find_replace_full_afterencode), $update, base64_decode($update->nextpage_reg), $update->nextpage_sub );
					if (!$fulltext) {
						$update->error_msg	.=	'<strong>'.date('Y-m-d H:i:s').'</strong><font color="red"><strong>'.JText::_('NOTGETCONTENT').':</strong></font> '.$item->get_link()."<br />\n";
						$check	=	false;
						$ok++;
						break;
					}
					$fulltext	.=	$readmore.'<p class="according">'.$update->according_to.'</p>';
					$fulltext	=	(intval($update->catads)) ? $fulltext.$ads : $fulltext;
					break;
					
				case 1:
					$introtext	=	$this->getregtext($item->get_link(), base64_decode($update->getintro_reg), $update->getintro_sub, base64_decode($update->find_replace_intro), base64_decode($update->find_replace_intro_afterencode), $update);
					if (!$introtext) {
						$update->error_msg	.=	'<strong>'.date('Y-m-d H:i:s').'</strong><font color="red"><strong>'.JText::_('NOTGETCONTENT').':</strong></font> '.$item->get_link()."<br />\n";
						$check	=	false;
						$ok++;
						break;
					}
					$introtext	=	(intval($update->catads)) ? $introtext : $ads.$introtext;
					$fulltext	=	$this->getregtext($item->get_link(), base64_decode($update->getfull_reg), $update->getfull_sub, base64_decode($update->find_replace_full), base64_decode($update->find_replace_full_afterencode), $update, base64_decode($update->nextpage_reg), $update->nextpage_sub );
					if (!$fulltext) {
						$update->error_msg	.=	'<strong>'.date('Y-m-d H:i:s').'</strong><font color="red"><strong>'.JText::_('NOTGETCONTENT').':</strong></font> '.$item->get_link()."<br />\n";
						$check	=	false;
						$ok++;
						break;					
					}
					$fulltext	.=	  $readmore.'<p class="according">'.$update->according_to.'</p>';
					$fulltext	=	(intval($update->catads)) ? $fulltext.$ads : $fulltext;
					break;
					
				case 2:
					$textfull	=	$this->getregtext($item->get_link(), base64_decode($update->getintro_reg), $update->getintro_sub, base64_decode($update->find_replace_intro), base64_decode($update->find_replace_intro_afterencode), $update, base64_decode($update->nextpage_reg), $update->nextpage_sub );
					if (!$textfull) {
						$update->error_msg	.=	'<strong>'.date('Y-m-d H:i:s').'</strong><font color="red"><strong>'.JText::_('NOTGETCONTENT').':</strong></font> '.$item->get_link()."<br />\n";						
						$check	=	false;
						$ok++;
						break;
					}
					if (intval($update->cut_content)) {
						$text		=	new AutoCutText($textfull, $update->numberword);
						$introtext	=	$text->getIntro();
						$introtext	=	(intval($update->catads)) ? $introtext : $ads.$introtext;
						$fulltext	=	$text->getFulltext().$readmore.'<p class="according">'.$update->according_to.'</p>';
						$fulltext	=	(intval($update->catads)) ? $fulltext.$ads : $fulltext;
					} else {
						$introtext	=	$textfull.$readmore.'<p class="according">'.$update->according_to.'</p>';
						$introtext	=	(intval($update->catads)) ? $introtext.$ads : $ads.$introtext;
						$fulltext	=	'';
					}
					break;
					
				case 3:
					$textfull		=	$desc;
					if (intval($update->cut_content)) {
						$text		=	new AutoCutText($textfull, $update->numberword);
						$introtext	=	$text->getIntro();
						$introtext	=	(intval($update->catads)) ? $introtext : $ads.$introtext;
						$fulltext	=	$text->getFulltext().$readmore.'<p class="according">'.$update->according_to.'</p>';
						$fulltext	=	(intval($update->catads)) ? $fulltext.$ads : $fulltext;
					} else {
						$introtext	=	$textfull.$readmore.'<p class="according">'.$update->according_to.'</p>';
						$introtext	=	(intval($update->catads)) ? $introtext.$ads : $ads.$introtext;
						$fulltext	=	'';
					}
					break;
					
			}
			
			if (!$check) {				
				continue;
			}
			
			$row->title		=	str_replace(array('&quot;', '&amp;'), array('"', '&'), $row->title);			
			$row->introtext	=	$econtent_utility->makesafehtml($introtext);
			$row->fulltext	=	$econtent_utility->makesafehtml($fulltext);
			
			$row->title		=	intval($update->title_ext_pos) ? $row->title.$update->title_ext : $update->title_ext. $row->title;
			
			$row->state		=	($this->checkkeyword_unpublish($row->title.' '.$row->introtext.' '.$row->fulltext, $update)) ? 0 : 1;
			
			$keysave	=	null;
			if (trim($update->keysave)!='') {
				$keysave	=	$this->filterkeyword($row->title.' '.$row->introtext.' '.$row->fulltext, $update->keysave);
			}

			$row->publish_up=	date('Y-m-d H:i:s',strtotime($now)+ (intval($update->publish_time)*3600));
			$row->publish_down = (intval($update->publish_down)==0) ? '0000-00-00 00:00:00' : date('Y-m-d H:i:s',strtotime($now)+ (intval($update->publish_time)*3600) + (intval($update->publish_down)*3600));
			$row->created	=	$now;
			$row->created_by= 	$update->created_by;
			if (empty($keysave)) {
				$row->sectionid	=	$update->sectionid;
				$row->catid		=	$update->catid;
			} else {
				$row->sectionid	=	$keysave['sectionid'] ? $keysave['sectionid'] : $update->sectionid;
				$row->catid		=	$keysave['catid'] ? $keysave['catid'] : $update->catid;
			}
			$row->access	=	$update->access;
			$row->version	= 	1;
			
			$metadata		=	$this->getmetadata($item->get_link());
			
			$row->metakey	=	$metadata['keywords'];
			$row->metadesc	=	$metadata['description'];
			$charset		=	$metadata['charset'];
			
			if ($charset!='auto') {
				$this->convert_utf_8($row, $charset, 0);
			}
			
			$link->link		=	$item->get_link();
			$link->title	=	$row->title;
			$link->sectionid=	$row->sectionid;
			$link->catid	=	$row->catid;
			
			if ((trim($update->t_from)!='') && (trim($update->t_to)!='')) {
				$this->translate($row, $update->t_from, $update->t_to);
			}
			
			if ($update->rewrite) {
				$this->rewrite_data($row, $update);
			}
			
			if ($row->check() && $link->check()) {
				$result	=	$dispatcher->trigger('onBeforeContentSave', array (&$row, true ));
				$row->store();
				
				if ($row->id){
					if ($update->front_page) {
						// check to set front-page
						$front_page_keyword		=	base64_decode($update->front_page_keyword);
						if ($front_page_keyword) {
							if ($this->checkfrontpage_keyword($front_page_keyword, $row->title.' '.$row->introtext.' '.$row->fulltext)){
								$res = $this->setfrontpage($row->id);
							}
						} else {
							$res	=	$this->setfrontpage($row->id);
						}
					}
					
					$link->articleid	= $row->id;
				}
				
				
				$link->store();
				$result	=	$dispatcher->trigger('onAfterContentSave', array (& $row, true ));
			}
		}
		
		return (($ok == 0)||((100-(($ok/count($items))*100))>=$config_percent));

	}
	
	/**
	 * Store HTML data
	 *
	 * @param obj $update
	 * @return bool
	 */
	function storeHTMLDatas(&$update, $config_percent){
		$dispatcher	=& JDispatcher::getInstance();
		if ($update->pid!=0) {			
			JPluginHelper::importPlugin('econtent_crawler');
			$rows  = null;
			$result = $dispatcher->trigger('onGetDataCrawler', array (&$update, &$rows,  true ));
			
			if (!$result) {
			    $update->error_msg .= '<strong>'.date('Y-m-d H:i:s').'</strong><font color="red"><strong>'.JText::_('NOTGETPLUGIN').':</strong></font> '.base64_decode($update->link)."<br />\n";
			    return false;
			}
			if (!$rows) {    
			    return false;
			}
			
			for ($i=0; $i<count($rows); $i++){
				$row	=	&JTable::getInstance('content');
				$link	=	&JTable::getInstance('Econtent_Content_Link','Table');
				$row->bind($rows[$i]);
				
				$link->link		=	$rows[$i]->link;
				$link->title	=	$rows[$i]->title;
				$link->sectionid=	$rows[$i]->sectionid;
				$link->catid	=	$rows[$i]->catid;
				$charset		=	$rows[$i]->charset;
			
				if ($charset!='auto') {
					$this->convert_utf_8($row, $charset, 1);
				}
				
				if ((trim($update->t_from)!='') && (trim($update->t_to)!='')) {
					$this->translate($row, $update->t_from, $update->t_to);
				}
				
				if ($update->rewrite) {
					$this->rewrite_data($row, $update);
				}
				
				if ($row->check() && $link->check()) {
					$result	=	$dispatcher->trigger('onBeforeContentSave', array (&$row, true ));
					$row->store();
					if ($row->id){
						if ($update->front_page) {
							// check to set front-page
							$front_page_keyword		=	base64_decode($update->front_page_keyword);
							if ($front_page_keyword) {
								if ($this->checkfrontpage_keyword($front_page_keyword, $row->title.' '.$row->introtext.' '.$row->fulltext)){
									$res = $this->setfrontpage($row->id);
								}
							} else {
								$res	=	$this->setfrontpage($row->id);
							}
						}
						
						$link->articleid	= $row->id;
					}
					$link->store();
					$result	=	$dispatcher->trigger('onAfterContentSave', array (& $row, true ));
				}
			}
			return true;
		}
		
		$now	=	&JFactory::getDate();
		$now	=	$now->toMySQL();
		
		
		JPluginHelper::importPlugin('content');
		
		$econtent_utility	=	new Econtent_utility();
		$updatelink		=	base64_decode($update->link);
		
		$links	=	$this->getlink($updatelink, base64_decode($update->getlink_reg), $update->getlink_sub, base64_decode($update->find_replace_links), $update);
		$titles	=	$this->gettitle($updatelink, base64_decode($update->gettitle_reg), $update->gettitle_sub, $update);
		
		$introout	=	((intval($update->dataway)==0) || (intval($update->dataway)==3)) ? $this->getintro($updatelink, base64_decode($update->getintro_reg), $update->getintro_sub, base64_decode($update->find_replace_intro), base64_decode($update->find_replace_intro_afterencode), $update) : true ;
		
		
		if (!$links || !$titles || !$introout) {
			$update->error_msg	.=	'<strong>'.date('Y-m-d H:i:s').'</strong><font color="red"><strong>'.JText::_('NOTGETLOCATION').':</strong></font> '.$updatelink."<br />\n";
			return false;
		}
		
		$links	=	array_slice($links , 0, $update->numbercontent );
		$titles	=	array_slice($titles , 0, $update->numbercontent );
		$introout=	is_array($introout) ? array_slice($introout, 0, $update->numbercontent) : $introout;
		
		$i =0;
		$ok	=	0;
		foreach ($links as $link) {
			
			if (!$this->checkstore($link)) {
				$i++;
				continue;
			}
			$row	=	&JTable::getInstance('content');
			$slink	=	&JTable::getInstance('Econtent_Content_Link','Table');
			
			
			$row->title		=	$titles[$i];			
			
			$ads			=	'<div class="ads_news">'.base64_decode($update->ads).'</div>';
			$readmore		=	(intval($update->readmore)) ? '<p class="readmore_news"><a href="'.$link.'">'.JText::_('VIEWDETAIL').'</a></p>' : '';
			
			$check			=	true;
			switch (intval($update->dataway)) {
				case 0:
					$introtext	=	$introout[$i];					
					$introtext	=	(intval($update->catads)) ? $introtext : $ads.$introtext;
					$fulltext	=	$this->getregtext($link, base64_decode($update->getfull_reg), $update->getfull_sub, base64_decode($update->find_replace_full), base64_decode($update->find_replace_full_afterencode), $update, base64_decode($update->nextpage_reg), $update->nextpage_sub );
					if (!$fulltext) {
						$update->error_msg	.=	'<strong>'.date('Y-m-d H:i:s').'</strong><font color="red"><strong>'.JText::_('NOTGETCONTENT').':</strong></font> '.$link."<br />\n";
						$check	=	false;
						$ok++;
						break;
					}
					$fulltext	.=	$readmore.'<p class="according">'.$update->according_to.'</p>';
					$fulltext	=	(intval($update->catads)) ? $fulltext.$ads : $fulltext;
					break;
					
				case 1:
					$introtext	=	$this->getregtext($link, base64_decode($update->getintro_reg), $update->getintro_sub, base64_decode($update->find_replace_intro), base64_decode($update->find_replace_intro_afterencode), $update);
					if (!$introtext) {
						$update->error_msg	.=	'<strong>'.date('Y-m-d H:i:s').'</strong><font color="red"><strong>'.JText::_('NOTGETCONTENT').':</strong></font> '.$link."<br />\n";
						$check	=	false;
						$ok++;
						break;
					}
					$introtext	=	(intval($update->catads)) ? $introtext : $ads.$introtext;
					$fulltext	=	$this->getregtext($link, base64_decode($update->getfull_reg), $update->getfull_sub, base64_decode($update->find_replace_full), base64_decode($update->find_replace_full_afterencode), $update, base64_decode($update->nextpage_reg), $update->nextpage_sub );
					if (!$fulltext) {
						$update->error_msg	.=	'<strong>'.date('Y-m-d H:i:s').'</strong><font color="red"><strong>'.JText::_('NOTGETCONTENT').':</strong></font> '.$link."<br />\n";
						$check	=	false;
						$ok++;
						break;					
					}
					$fulltext	.=	  $readmore.'<p class="according">'.$update->according_to.'</p>';
					$fulltext	=	(intval($update->catads)) ? $fulltext.$ads : $fulltext;
					break;
					
				case 2:
					$textfull	=	$this->getregtext($link, base64_decode($update->getintro_reg), $update->getintro_sub, base64_decode($update->find_replace_intro), base64_decode($update->find_replace_intro_afterencode), $update, base64_decode($update->nextpage_reg), $update->nextpage_sub);
					
					if (!$textfull) {
						$update->error_msg	.=	'<strong>'.date('Y-m-d H:i:s').'</strong><font color="red"><strong>'.JText::_('NOTGETCONTENT').':</strong></font> '.$link."<br />\n";
						$check	=	false;
						$ok++;
						break;
					}
					if (intval($update->cut_content)) {
						$text		=	new AutoCutText($textfull, $update->numberword);
						$introtext	=	$text->getIntro();
						
						$introtext	=	(intval($update->catads)) ? $introtext : $ads.$introtext;
						$fulltext	=	$text->getFulltext().$readmore.'<p class="according">'.$update->according_to.'</p>';
						$fulltext	=	(intval($update->catads)) ? $fulltext.$ads : $fulltext;
					} else {
						$introtext	=	$textfull.$readmore.'<p class="according">'.$update->according_to.'</p>';
						$introtext	=	(intval($update->catads)) ? $introtext.$ads : $ads.$introtext;
						$fulltext	=	'';
					}
					break;
					
				case 3:
					$textfull		=	$introout[$i];
					if (intval($update->cut_content)) {
						$text		=	new AutoCutText($textfull, $update->numberword);
						$introtext	=	$text->getIntro();
						$introtext	=	(intval($update->catads)) ? $introtext : $ads.$introtext;
						$fulltext	=	$text->getFulltext().$readmore.'<p class="according">'.$update->according_to.'</p>';
						$fulltext	=	(intval($update->catads)) ? $fulltext.$ads : $fulltext;
					} else {
						$introtext	=	$textfull.$readmore.'<p class="according">'.$update->according_to.'</p>';
						$introtext	=	(intval($update->catads)) ? $introtext.$ads : $ads.$introtext;
						$fulltext	=	'';
					}
					break;
					
			}
			
			if (!$check) {
				$i++;
				continue;
			}
			
			$row->title		=	str_replace(array('&quot;', '&amp;'), array('"', '&'), $row->title);
			$row->introtext	=	$econtent_utility->makesafehtml($introtext);
			$row->fulltext	=	$econtent_utility->makesafehtml($fulltext);
			if (!$this->checkkeyword($row->title, $update) && !$this->checkkeyword($row->introtext.' '.$row->fulltext,$update)) {
				$i++;
				continue;
			}
			
			$row->title		=	intval($update->title_ext_pos) ? $row->title.$update->title_ext : $update->title_ext. $row->title;
			
			$row->state		=	($this->checkkeyword_unpublish($row->title.' '.$row->introtext.' '.$row->fulltext, $update)) ? 0 : 1;
			
			$keysave	=	null;
			if (trim($update->keysave)!='') {
				
				$keysave	=	$this->filterkeyword($row->title.' '.$row->introtext.' '.$row->fulltext, $update->keysave);
				
			}

			$row->publish_up=	date('Y-m-d H:i:s',strtotime($now)+ (intval($update->publish_time)*3600));
			$row->publish_down = (intval($update->publish_down)==0) ? '0000-00-00 00:00:00' : date('Y-m-d H:i:s',strtotime($now)+ (intval($update->publish_time)*3600) + (intval($update->publish_down)*3600));
			$row->created	=	$now;
			$row->created_by= 	$update->created_by;
			if (empty($keysave)) {
				$row->sectionid	=	$update->sectionid;
				$row->catid		=	$update->catid;
			} else {
				$row->sectionid	=	$keysave['sectionid'] ? $keysave['sectionid'] : $update->sectionid;
				$row->catid		=	$keysave['catid'] ? $keysave['catid'] : $update->catid;
			}
			$row->access	=	$update->access;
			$row->version	= 	1;
			
			$metadata		=	$this->getmetadata($link);
			
			$row->metakey	=	$metadata['keywords'];
			$row->metadesc	=	$metadata['description'];
			$charset		=	$metadata['charset'];			
			
			if ($charset!='auto') {
				$this->convert_utf_8($row, $charset, 1);
			}			
			
			$slink->link		=	$link;
			$slink->title		=	$row->title;
			$slink->sectionid	=	$row->sectionid;
			$slink->catid		=	$row->catid;
				
			if ((trim($update->t_from)!='') && (trim($update->t_to)!='')) {
				$this->translate($row, $update->t_from, $update->t_to);
			}
			
			if ($update->rewrite) {
				$this->rewrite_data($row, $update);
			}
			
			if ($row->check() && $slink->check()) {
				$result	=	$dispatcher->trigger('onBeforeContentSave', array (&$row, true ));
				$row->store();
				
				if ($row->id){
					if ($update->front_page) {
						// check to set front-page
						$front_page_keyword		=	base64_decode($update->front_page_keyword);
						if ($front_page_keyword) {
							if ($this->checkfrontpage_keyword($front_page_keyword, $row->title.' '.$row->introtext.' '.$row->fulltext)){
								$res = $this->setfrontpage($row->id);
							}
						} else {
							$res	=	$this->setfrontpage($row->id);
						}
					}
					
					$slink->articleid	= $row->id;
				}

				$slink->store();
				$result	=	$dispatcher->trigger('onAfterContentSave', array (& $row, true ));
			}
			$i++;
		}
		
		return (($ok == 0) || ((100-(($ok/count($links))*100))>=$config_percent));

	}
	
	function setfrontpage($content_id) {
		$db		=	&JFactory::getDBO();
		$query	=	"INSERT INTO #__content_frontpage SET
							content_id	=	$content_id, ordering = 0";
		$db->setQuery($query);
		$db->query();
		return true;
	}
	
	/**
	 * Check front-page keyword
	 *
	 * @param string $keyword
	 * @param string $text
	 * @return bool
	 */
	function checkfrontpage_keyword($keyword, $data) {
		$regword	=	'/\[(.*?)\]/i';
		$datatext	=	JFilterOutput::cleanText($data);
		preg_match_all($regword, $keyword, $matches);
		
		if (!count($matches[0])) {
			return false;
		}
		
		for ($i =0; $i<count($matches[0]); $i++){
			$word	=	trim($matches[1][$i]);
			
			if (preg_match('/'.preg_quote($word,'/').'/i', $datatext)) {
				return true;
			}
			
		}
		return false;
	}
	
	function utf8_entity_decode($entity)
	{
		$convmap = array(0x0, 0x10000, 0, 0xfffff);
		return mb_decode_numericentity($entity[0], $convmap, 'UTF-8');
	}
	
	function convert_utf_8(& $row, $charset, $ishtml = 1){
		
		if ($ishtml) {
			$row->title 			= mb_convert_encoding($row->title, 'UTF-8', $charset);	
		}
		$row->introtext			= mb_convert_encoding($row->introtext, 'UTF-8', $charset);
		$row->fulltext 			= mb_convert_encoding($row->fulltext, 'UTF-8', $charset);
		$row->metakey 			= mb_convert_encoding($row->metakey, 'UTF-8', $charset);
		$row->metadesc 			= mb_convert_encoding($row->metadesc, 'UTF-8', $charset);
		
		$row->title 			= mb_convert_encoding($row->title, 'UTF-8', 'UTF-8');
		$row->introtext			= mb_convert_encoding($row->introtext, 'UTF-8', 'UTF-8');
		$row->fulltext 			= mb_convert_encoding($row->fulltext, 'UTF-8', 'UTF-8');
		$row->metakey 			= mb_convert_encoding($row->metakey, 'UTF-8', 'UTF-8');
		$row->metadesc 			= mb_convert_encoding($row->metadesc, 'UTF-8', 'UTF-8');
		
		$row->title 			= preg_replace_callback('/&#\d{2,5};/u', array(&$this,"utf8_entity_decode"), $row->title );
		$row->introtext 		= preg_replace_callback('/&#\d{2,5};/u', array(&$this,"utf8_entity_decode"), $row->introtext );
		$row->fulltext 			= preg_replace_callback('/&#\d{2,5};/u', array(&$this,"utf8_entity_decode"), $row->fulltext );
		$row->metakey 			= preg_replace_callback('/&#\d{2,5};/u', array(&$this,"utf8_entity_decode"), $row->metakey );
		$row->metadesc 			= preg_replace_callback('/&#\d{2,5};/u', array(&$this,"utf8_entity_decode"), $row->metadesc );
	}
	
	function getmetadata($link){
		$docURL	=	new Services_Yadis_PlainHTTPFetcher();
		$link	=	preg_replace('/&amp;/', '&', $link);
		$file	=	$docURL->get($link);
		if (!$file) {
			return array('keywords'=> null, 'description'=> null, 'charset'=> 'auto');
		}
		
		$charset	=	'auto';
		if (preg_match('/charset=["\']?([a-zA-Z0-9-]*?)["\']?(>|\s|;)/i', $file->body, $matchcharset)) {
			$charset	=	$matchcharset[1];
		}
		if (!preg_match('/<meta\s*name="keywords"\s*content=["\'](.*?)["\']/i', $file->body, $matchkeyword) || !preg_match('/<meta\s*name="description"\s*content=["\'](.*?)["\']/i', $file->body, $matchdescription)) {
			return array('keywords'=> null, 'description'=> null, 'charset'=> $charset);
		}		
		
		return array('keywords'=> $matchkeyword[1], 'description'=> $matchdescription[1], 'charset'=> $charset);
	}
	
	/**
	 * get data with regexp
	 *
	 * @param string $url
	 * @param string $reg
	 * @param int $subreg
	 * @param string $findreplace
	 * @param string $findreplaceencode
	 * @param obj $update
	 * @return data HTML
	 */
	function getregtext($url, $reg, $subreg, $findreplace, $findreplaceencode, &$update, $nextpage = '', $np_sub = 0, $k = 2){		
		$docURL	=	new Services_Yadis_PlainHTTPFetcher();
		$updatelink		=	base64_decode($update->link);
			// Get content file
		$url	=	preg_replace('/&amp;/', '&', $url);
		if (intval($update->validate_cookie)) {
			$headers	=	$this->getHeaders($updatelink);
		}
		
		$file	=	intval($update->validate_cookie)? $docURL->get($url,$headers) : $docURL->get($url);		
		
		if (!$file) {
			$update->error_msg	.=	'<strong>'.date('Y-m-d H:i:s').'</strong><font color="red"><strong>'.JText::_('NOTGETLOCATION').':</strong></font> '.$updatelink."<br />\n";
			return false;
		}
		
		if (!@preg_match( $reg, $file->body, $matches)) {
			$update->error_msg	.=	'<strong>'.date('Y-m-d H:i:s').'</strong><font color="red"><strong>'.JText::_('NOTGETREGEXP').':</strong></font> '.htmlspecialchars($reg)."<br />\n";
			return false;
		}
		if (!isset($matches[$subreg])) {
			$update->error_msg	.=	'<strong>'.date('Y-m-d H:i:s').'</strong><font color="red"><strong>'.JText::_('NOTGETSUBREG').':</strong></font> '.$subreg."<br />\n";
			return false;
		}
		$data	=	$matches[$subreg];
		
		$data	=	$this->makesafelink($data, $url);

		if (intval($update->get_img)) {
			$regimg	=	'/(&lt;|<)img\s.*?src=["\'](.*?)["\'].*?\/?(&gt;|>)/i';
			preg_match_all($regimg, $data, $imatches);			
			for ($i = 0; $i< count($imatches[0]); $i++){				
				$src	=	$imatches[2][$i];				
				$imgobj	=	new GetImages($src, $update);
				$img_link=	$imgobj->getNewlink();
				$data	=	str_replace($src, $img_link, $data);
			}					
		}
		
		$data	=	$this->findreplace($data, $findreplace);
		$data	=	$this->findreplaceencode($data, $findreplaceencode);
		
		if ($nextpage!='') {
			if (!@preg_match($nextpage, $file->body, $match)) {
				return $data;
			} else {		
				$url		=	$this->makelink($updatelink, $match[$np_sub]);
				if ($update->pagebreak) {
					$title		=	(@preg_match(base64_decode($update->pagebreak_reg),$file->body, $match)) ? $match[$update->pagebreak_sub] : JText::_('PAGE').' '.$k; 	
				} else {
					$title		=	'';
				}
				$pagebreak	=	($update->pagebreak) ? '<hr title="'.$title.'" class="system-pagebreak" />' : '';
				return $data.$pagebreak.$this->getregtext($url, $reg, $subreg, $findreplace, $findreplaceencode, $update, $nextpage, $np_sub, $k+1);
			}
		} else {
			return $data;	
		}
	}
	
	/**
	 * Filter section and category to save articles
	 *
	 * @param string $data
	 * @param string $keyword
	 * @return array
	 */
	function filterkeyword($data, $keyword){
		$regword	=	'/\[(.*?)\]/i';
		$datatext	=	JFilterOutput::cleanText($data);
		preg_match_all($regword, $keyword, $matches);
		
		if (!count($matches[0])) {
			return null;
		}
		
		$db	=	$this->_db;
		$sectionid	=	$catid	=	null;
		
		for ($i =0; $i<count($matches[0]); $i++){
			$word	=	trim($matches[1][$i]);
			$arr_word	=	explode('=>',$word);
			
			if (count($arr_word)<2) {
				continue;
			}
			
			$key 	=	$arr_word[0];
			$sectcat=	$arr_word[1];
			
			if (preg_match('/'.preg_quote($key,'/').'/i', $datatext)) {
				$arr_seccat	=	explode(',',$sectcat);
				if (count($arr_seccat)<2) {
					continue;
				}
				return array('sectionid'=> $arr_seccat[0], 'catid'=> $arr_seccat[1]);
			}
			
		}
		return null;
	}
	
	function checkkeyword_unpublish($data, &$update){
		$data	=	JFilterOutput::cleanText($data);
		$regword	=	'/\[(.*?)\]/i';
		preg_match_all($regword, $update->keyword_unpublish, $matches);
		
		if (!count($matches[0])) {			
			return false;
		}
		
		for ($i =0; $i<count($matches[0]); $i++){
			if (preg_match('/'.preg_quote($matches[1][$i],'/').'/i', $data)) {				
				return true;
			}
		}
		
		return false;
		
	}
	
	function checkkeyword($data, &$update){
		$data	=	JFilterOutput::cleanText($data);
		$regword	=	'/\[(.*?)\]/i';
		preg_match_all($regword, $update->keyword, $matches);
		
		if (!count($matches[0])) {			
			return true;
		}
		
		for ($i =0; $i<count($matches[0]); $i++){
			if (preg_match('/'.preg_quote($matches[1][$i],'/').'/i', $data)) {				
				return true;
			}
		}
		
		return false;
		
	}
	
	function filterdata($data, $findreplace, $findreplaceencode, &$update){
		if (intval($update->get_img)) {
			$regimg	=	'/(&lt;|<)img\s.*?src=["\'](.*?)["\'].*?\/?(&gt;|>)/i';
			preg_match_all($regimg, $data, $matches);
			for ($i = 0; $i< count($matches[0]); $i++){
				$src	=	$matches[2][$i];
				$imgobj	=	new GetImages($src, $update);
				$img_link=	$imgobj->getNewlink();
				$data	=	str_replace($src, $img_link, $data);
			}					
		}
		
		$data	=	$this->findreplace($data, $findreplace);
		$data	=	$this->findreplaceencode($data, $findreplaceencode);
		
		return $data;
	}

	function checkstore($link){
		$db	=	$this->_db;
		$query	=	"SELECT * FROM #__econtent_content_link WHERE link = '".$link."'";
		$db->setQuery($query);
		$rows	=	$db->loadObjectList();
		if (count($rows)){
			return false;
		}
		return true;
	}

	function getUpdateLists(){
		$now	=	date('Y-m-d H:i:s');
		$db		=	$this->_db;
		$query	=	"SELECT * FROM #__econtent WHERE (published = 1)";
		$db->setQuery($query);
		$rows	=	$db->loadObjectList();
		$rows_update	=	array();
		for ($i =0; $i< count($rows); $i++){
			if ((strtotime($rows[$i]->last_update)+(intval($rows[$i]->time_update)*60))<= strtotime($now)) {
				$rows_update[]	=	$rows[$i];
			}
		}
		return $rows_update;
	}
	
	function getMessage($row){
		global $mainframe;
		$FromName	= $mainframe->getCfg('fromname');
		$message = '';
		ob_start();
		echo JText::_('DEAR'); ?> <?php echo $FromName; ?>,
		<br/><br/>
		<?php echo 'com_econtent'; ?>
		 <br/><br/>
		<?php echo 'ID:'.$row->id; ?> <br/>
		<?php echo 'Link:'.base64_decode($row->link); ?> <br/>
		<?php echo 'Number Error:'.$row->error_counter; ?> <br/>		
		<?php echo 'Error:'.$row->error_msg; ?> <br/>		
		<?php
		$message=ob_get_contents();
		ob_end_clean();
		
		return $message;
	}
	
	function findreplaceencode($data, $find_replace){
		$encode		=	array();
		$decode		=	array();
		$arr_reg	=	explode("\n", $find_replace);
		
		if (trim($arr_reg[0])=='') {
			return $data;
		}
		
		if (@preg_match_all('/<script.*?>.*?<\/script>/si', $data, $matches)) {
			for ($i = 0; $i<count($matches[0]); $i++){				
				array_push($encode, md5($matches[0][$i]));
				array_push($decode, $matches[0][$i]);
				$data = str_replace($matches[0][$i], md5($matches[0][$i]), $data);
			}
		}
		
		if (@preg_match_all('/(&lt;|<)a\s+.*?href=["\'](.*?)["\'](&gt;|>)(.*?)(&lt;|<)\/a(&gt;|>)/is', $data, $matches)) {
			for ($i = 0; $i<count($matches[0]); $i++){				
				array_push($encode, md5($matches[0][$i]));
				array_push($decode, $matches[0][$i]);
				$data = str_replace($matches[0][$i], md5($matches[0][$i]), $data);
			}
		}
		
		if (@preg_match_all('/(&lt;|<)img\s.*?src=["\'](.*?)["\'].*?\/(&gt;|>)/i', $data, $matches)) {
			for ($i = 0; $i<count($matches[0]); $i++){				
				array_push($encode, md5($matches[0][$i]));
				array_push($decode, $matches[0][$i]);
				$data = str_replace($matches[0][$i], md5($matches[0][$i]), $data);
			}
		}
		
		foreach ($arr_reg as $findreplace) {
			if (trim($findreplace)!='') {
				$fr		=	explode('<=>', $findreplace);
				$reg 	=	$fr[0];
				$replace=	$fr[1];				
				
				@preg_match_all($reg, $data, $matches);
				
				for ($i = 0; $i< count($matches[0]); $i++){
					$match	=	$matches[0][$i];
					$data	=	str_replace($match, $replace, $data);
				}
			}
		}
		
		for ($i =0; $i<count($encode); $i++){
			$data	=	str_replace($encode[$i], $decode[$i], $data);
		}
		
		return $data;
	}
	
	function findreplace($data, $find_replace){
		
		$arr_reg	=	explode("\n", $find_replace);
		
		if (trim($arr_reg[0])=='') {
			return $data;
		}
		
		foreach ($arr_reg as $findreplace) {
			if (trim($findreplace)!='') {
				$fr		=	explode('<=>', $findreplace);
				$reg 	=	$fr[0];
				$replace=	$fr[1];				
				
				@preg_match_all($reg, $data, $matches);
				
				for ($i = 0; $i< count($matches[0]); $i++){
					$match	=	$matches[0][$i];
					$data	=	str_replace($match, $replace, $data);
				}
			}
		}		
		
		return $data;
	}
	
	function getlink($url, $reg, $subreg, $findreplace, &$update) {
		$link		=	preg_replace('/&amp;/', '&', $url);
		$reg		=	$reg;
		$docURL	=	new Services_Yadis_PlainHTTPFetcher();	
		$linkdata	=	array()	;
		
		// Get content file
		$file	=	$docURL->get($link);
		
		if(!$file)
		{
			$update->error_msg	.=	'<strong>'.date('Y-m-d H:i:s').'</strong><font color="red"><strong>'.JText::_('NOTGETLOCATION').':</strong></font> '.$link."<br />\n";
			return false;
		} else {
			if (!@preg_match_all( $reg, $file->body, $matches)) {
				$update->error_msg	.=	'<strong>'.date('Y-m-d H:i:s').'</strong><font color="red"><strong>'.JText::_('NOTGETREGEXP').':</strong></font> '.htmlspecialchars($reg)."<br />\n";
				return false;
			}
			if (!isset($matches[$subreg])) {
				$update->error_msg	.=	'<strong>'.date('Y-m-d H:i:s').'</strong><font color="red"><strong>'.JText::_('NOTGETSUBREG').':</strong></font> '.$subreg."<br />\n";
				return false;
			}
			
			for ($i =0; $i<count($matches[0]); $i++){
				$safelink	=	$this->makelink($link, $matches[$subreg][$i]);
				$safelink	=	$this->findreplace($safelink, $findreplace);
				$linkdata[]	=	$safelink;
			}
			
		}
		return $linkdata;
	}
	
	function gettitle($url, $reg, $subreg, &$update){
		$link		=	preg_replace('/&amp;/', '&', $url);
		$reg		=	$reg;
		$docURL	=	new Services_Yadis_PlainHTTPFetcher();	
		$titledata	=	array()	;
		
			// Get content file
		$file	=	$docURL->get($link);
		
		if(!$file)
		{
			$update->error_msg	.=	'<strong>'.date('Y-m-d H:i:s').'</strong><font color="red"><strong>'.JText::_('NOTGETLOCATION').':</strong></font> '.$link."<br />\n";
			return false;
		} else {
			
			if (!@preg_match_all( $reg, $file->body, $matches)) {
				$update->error_msg	.=	'<strong>'.date('Y-m-d H:i:s').'</strong><font color="red"><strong>'.JText::_('NOTGETREGEXP').':</strong></font> '.htmlspecialchars($reg)."<br />\n";
				return false;
			}
			if (!isset($matches[$subreg])) {
				$update->error_msg	.=	'<strong>'.date('Y-m-d H:i:s').'</strong><font color="red"><strong>'.JText::_('NOTGETSUBREG').':</strong></font> '.$subreg."<br />\n";
				return false;
			}
			
			for ($i =0; $i<count($matches[0]); $i++){
				$titledata[]	=	$matches[$subreg][$i];
			}
			
		}
		return $titledata;
	}
	
	function getintro($url, $reg, $subreg, $findreplace, $findreplaceencode, &$update){		
		$link		=	preg_replace('/&amp;/', '&', $url);
		$reg		=	$reg;
		$intro		=	array();
		
		$docURL	=	new Services_Yadis_PlainHTTPFetcher();
		
			// Get content file
		$file	=	$docURL->get($link);
		
		if(!$file)
		{
			$update->error_msg	.=	'<strong>'.date('Y-m-d H:i:s').'</strong><font color="red"><strong>'.JText::_('NOTGETLOCATION').':</strong></font> '.$link."<br />\n";
			return false;
		} else {
			
			if (!@preg_match_all( $reg, $file->body, $matches)) {
				
				$update->error_msg	.=	'<strong>'.date('Y-m-d H:i:s').'</strong><font color="red"><strong>'.JText::_('NOTGETREGEXP').':</strong></font> '.htmlspecialchars($reg)."<br />\n";
				return false;
			}
			if (!isset($matches[$subreg])) {
				$update->error_msg	.=	'<strong>'.date('Y-m-d H:i:s').'</strong><font color="red"><strong>'.JText::_('NOTGETSUBREG').':</strong></font> '.$subreg."<br />\n";
				return false;
			}
			
			
			for ($i =0; ($i<count($matches[0])) && ($i<intval($update->numbercontent)); $i++){
				$data	=	$matches[$subreg][$i];
				$data	=	$this->makesafelink($data, $link);
				if (intval($update->get_img)) {
					$regimg	=	'/(&lt;|<)img\s.*?src=["\'](.*?)["\'].*?\/?(&gt;|>)/i';					
					preg_match_all($regimg, $data, $imatches);
					
					for ($j = 0; $j< count($imatches[0]); $j++){
						$src	=	$imatches[2][$j];
						$imgobj	=	new GetImages($src, $update);
						$img_link=	$imgobj->getNewlink();
						$data	=	str_replace($src, $img_link, $data);
					}	
					
				}
				
				$data	=	$this->findreplace($data, $findreplace);
				$data	=	$this->findreplaceencode($data, $findreplaceencode);
				
				$intro[]=	$data;
			}
			
		}
		return $intro;
	}
	
	function makesafelink($data, $host){
		
//		preg_match_all('/(href|src)=(.*?)\s/i', $data, $matches);
//		for ($i=0; $i<count($matches[0]); $i++){
//			if (!preg_match('/^["\'].*/i',$matches[2][$i])) {
//				$data		=		str_replace($matches[2][$i], '"'.$matches[2][$i], $data);
//			}
//			if (!preg_match('/.*["\']$/i',$matches[2][$i])) {
//				$data		=		str_replace($matches[2][$i], $matches[2][$i].'"', $data);
//			}
//		}
		
		$reglink	=	'/(href|src)=["\'](.*?)["\']/i';
		preg_match_all($reglink, $data, $matches);
		for ($i=0; $i<count($matches[0]); $i++){
			$data	=	str_replace($matches[0][$i],$matches[1][$i].'="'.$this->makelink($host, $matches[2][$i]).'"', $data);
		}
		return $data;
	}
	
	function makelink($host='', $link){
		
		if (preg_match('/^http:\/\/.*/i', $link) || preg_match('/^mailto:.*/i', $link)) {
			return $link;
		} elseif (preg_match('/^\/.*/i', $link)) {			
//			$domain		=	new Only_Domain();
//			$domain->url($host);
			$referer = parse_url($host);
			$domain = $referer['host'];
			return 'http://'.$domain.$link;
		} else{
			
			$slash = strrpos($host, '/') + 1;			
			$host	=	substr($host,0, $slash);
			
			return $host.$link;
		}
	}
	
	function getHeaders($url){
		$docURL	=	new Services_Yadis_PlainHTTPFetcher();
		$file	=	$docURL->get($url);
		$headers[]	=	'Cookie: '.$file->headers['Set-Cookie'];
		return $headers;
	}
	
	/**
	 * Translate data using Google Translate
	 *
	 * @param Article data $content
	 * @param Lang from $src
	 * @param Lang to $dst
	 * @return bool
	 */
	function translate(&$content, $src, $dst){
		//build a page to translate
		$pageContent = '';
		
		$titleHashBegin = md5('NEWS_CRAWLER_BEGIN_TITLE_AREA');
		$titleHashEnd = md5('NEWS_CRAWLER_END_TITLE_AREA');
		$pageContent .= $titleHashBegin . ' ' . $content->title . ' ' . $titleHashEnd;
		$pageContent .= "<br />";
		
		$introtextHashBegin = md5('NEWS_CRAWLER_BEGIN_INTROTEXT_AREA');
		$introtextHashEnd = md5('NEWS_CRAWLER_END_INTROTEXT_AREA');
		$pageContent .= $introtextHashBegin . ' ' . $content->introtext . ' ' . $introtextHashEnd;
		$pageContent .= "<br />";
		
		$fulltextHashBegin = md5('NEWS_CRAWLERD_BEGIN_FULLTEXT_AREA');
		$fulltextHashEnd = md5('NEWS_CRAWLER_END_FULLTEXT_AREA');
		$pageContent .= $fulltextHashBegin . ' ' . $content->fulltext . ' ' . $fulltextHashEnd;
		$pageContent .= "<br />";
		
		$metakeyHashBegin = md5('NEWS_CRAWLER_BEGIN_METAKEY_AREA');
		$metakeyHashEnd = md5('NEWS_CRAWLER_END_METAKEY_AREA');
		$pageContent .= $metakeyHashBegin . ' ' . $content->metakey . ' ' . $metakeyHashEnd;
		$pageContent .= "<br />";
		
		$metadescHashBegin = md5('NEWS_CRAWLER_BEGIN_METADESC_AREA');
		$metadescHashEnd = md5('NEWS_CRAWLER_END_METADESC_AREA');
		$pageContent .= $metadescHashBegin . ' ' . $content->metadesc . ' ' . $metadescHashEnd;
		$pageContent .= "<br />";		
		
		//require helper
		require_once(JPATH_COMPONENT.DS.'helpers'.DS.'translator.php');
		$translator = new Econtent_translator();
		$languagePair	=	$src.'|'.$dst;
		$tsl_pageContent = $translator->translate($languagePair, $pageContent);
		//get title:
		if (preg_match('/' . $titleHashBegin . '(.*?)' . $titleHashEnd . '/m', $tsl_pageContent, $match)) {
			$content->title			=	trim($match[1]);			
		} else {
			return false;
		}
		
		//get introtext:
		if (preg_match('/' . $introtextHashBegin . '(.*?)' . $introtextHashEnd . '/m', $tsl_pageContent, $match)) {
			$content->introtext		=	trim($match[1]);			
		} else {
			return false;
		}
		
		//get fulltext:
		if (preg_match('/' . $fulltextHashBegin . '(.*?)' . $fulltextHashEnd . '/m', $tsl_pageContent, $match)) {
			$content->fulltext		=	trim($match[1]);			
		} else {
			return false;
		}
		
		//get metakey:
		if (preg_match('/' . $metakeyHashBegin . '(.*?)' . $metakeyHashEnd . '/m', $tsl_pageContent, $match)) {
			$content->metakey		=	trim($match[1]);			
		} else {
			return false;
		}
		
		//get metadesk:
		if (preg_match('/' . $metadescHashBegin . '(.*?)' . $metadescHashEnd . '/m', $tsl_pageContent, $match)) {
			$content->metadesc		=	trim($match[1]);			
		} else {
			return false;
		}
		
		return true;
	}
	
	/**
	 * Rewrite English Toolby styleanddesign.nl
	 *
	 * @param article data $content
	 * @param news_crawler $update
	 * @return bool
	 */
	function rewrite_data(& $content, $update){
		$docURL	=	new Services_Yadis_PlainHTTPFetcher();
		$file	=	$docURL->get('http://styleanddesign.nl/rewrite/');
		$headers[]	=	'Cookie: '.$file->headers['Set-Cookie'];
		$headers[]	=	'Date: '.	$file->headers['Date'];
		$headers[]	=	'Server: '. $file->headers['Server'];
		$headers[]	=	'X-Powered-By: '. $file->headers['X-Powered-By'];
		$headers[]	=	'Expires: '. $file->headers['Expires'];
		$headers[]	=	'Cache-Control: ' . $file->headers['Cache-Control'];
		$headers[]	=	'Pragma: '.$file->headers['Pragma'];
		$headers[]	=	'Vary: '.$file->headers['Vary'];
		$pageContent = '';
		$titleHashBegin = md5('NEWS_CRAWLER_BEGIN_TITLE_AREA');
		$titleHashEnd = md5('NEWS_CRAWLER_END_TITLE_AREA');
		$pageContent .= $titleHashBegin . ' ' . $content->title . ' ' . $titleHashEnd;
		$pageContent .= "<br />";
		
		$introtextHashBegin = md5('NEWS_CRAWLER_BEGIN_INTROTEXT_AREA');
		$introtextHashEnd = md5('NEWS_CRAWLER_END_INTROTEXT_AREA');
		$pageContent .= $introtextHashBegin . ' ' . $content->introtext . ' ' . $introtextHashEnd;
		$pageContent .= "<br />";
		
		$fulltextHashBegin = md5('NEWS_CRAWLERD_BEGIN_FULLTEXT_AREA');
		$fulltextHashEnd = md5('NEWS_CRAWLER_END_FULLTEXT_AREA');
		$pageContent .= $fulltextHashBegin . ' ' . $content->fulltext . ' ' . $fulltextHashEnd;
		$pageContent .= "<br />";
		
		$metakeyHashBegin = md5('NEWS_CRAWLER_BEGIN_METAKEY_AREA');
		$metakeyHashEnd = md5('NEWS_CRAWLER_END_METAKEY_AREA');
		$pageContent .= $metakeyHashBegin . ' ' . $content->metakey . ' ' . $metakeyHashEnd;
		$pageContent .= "<br />";
		
		$metadescHashBegin = md5('NEWS_CRAWLER_BEGIN_METADESC_AREA');
		$metadescHashEnd = md5('NEWS_CRAWLER_END_METADESC_AREA');
		$pageContent .= $metadescHashBegin . ' ' . $content->metadesc . ' ' . $metadescHashEnd;
		$pageContent .= "<br />";
		
		$file			=	$docURL->post('http://styleanddesign.nl/rewrite/rewrite.php', 'article='.urlencode($pageContent), $headers);
		$tsl_pageContent=	$file->body;
		//get title:
		if (preg_match('/' . $titleHashBegin . '(.*?)' . $titleHashEnd . '/s', $tsl_pageContent, $match)) {
			$content->title			=	trim($match[1]);			
		} else {
			return false;
		}
		
		//get introtext:
		if (preg_match('/' . $introtextHashBegin . '(.*?)' . $introtextHashEnd . '/s', $tsl_pageContent, $match)) {
			$content->introtext		=	trim($match[1]);			
		} else {
			return false;
		}
		
		//get fulltext:
		if (preg_match('/' . $fulltextHashBegin . '(.*?)' . $fulltextHashEnd . '/s', $tsl_pageContent, $match)) {
			$content->fulltext		=	trim($match[1]);			
		} else {
			return false;
		}
		
		//get metakey:
		if (preg_match('/' . $metakeyHashBegin . '(.*?)' . $metakeyHashEnd . '/s', $tsl_pageContent, $match)) {
			$content->metakey		=	trim($match[1]);			
		} else {
			return false;
		}
		
		//get metadesk:
		if (preg_match('/' . $metadescHashBegin . '(.*?)' . $metadescHashEnd . '/s', $tsl_pageContent, $match)) {
			$content->metadesc		=	trim($match[1]);			
		} else {
			return false;
		}
		
		return true;
	}

}
